package com.jiuqi.dna.ide.designer.policies;

import com.jiuqi.dna.ide.designer.commands.LinkChangeCommand;
import com.jiuqi.dna.ide.designer.commands.LinkCreateCommand;
import com.jiuqi.dna.ide.designer.elements.FigureElement;
import com.jiuqi.dna.ide.designer.elements.IFigureElement;
import com.jiuqi.dna.ide.designer.elements.ILinkElement;
import com.jiuqi.dna.ide.designer.elements.LinkElement;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.ReconnectRequest;

/* loaded from: com_jiuqi_dna_ide_designer_policies.jar:com/jiuqi/dna/ide/designer/policies/NodeElementEditPolicy.class */
public class NodeElementEditPolicy extends GraphicalNodeEditPolicy {
    protected Command getConnectionCompleteCommand(CreateConnectionRequest request) {
        LinkCreateCommand cmd = request.getStartCommand();
        cmd.getLink().setTarget((IFigureElement) getHost().getModel());
        return cmd;
    }

    protected Command getConnectionCreateCommand(CreateConnectionRequest request) {
        FigureElement figureElement = (IFigureElement) getHost().getModel();
        LinkElement link = new LinkElement();
        if (figureElement instanceof FigureElement) {
            link.setDesigner(figureElement.getDesigner());
        }
        link.setSource(figureElement);
        LinkCreateCommand cmd = new LinkCreateCommand(link, figureElement.getRoot());
        request.setStartCommand(cmd);
        return cmd;
    }

    protected Command getReconnectSourceCommand(ReconnectRequest request) {
        ILinkElement link = (ILinkElement) request.getConnectionEditPart().getModel();
        IFigureElement source = (IFigureElement) getHost().getModel();
        LinkChangeCommand cmd = new LinkChangeCommand(link, source, true);
        return cmd;
    }

    protected Command getReconnectTargetCommand(ReconnectRequest request) {
        ILinkElement link = (ILinkElement) request.getConnectionEditPart().getModel();
        IFigureElement target = (IFigureElement) getHost().getModel();
        LinkChangeCommand cmd = new LinkChangeCommand(link, target, false);
        return cmd;
    }
}
